function [pick, pick_snr] = picker(u, t, t0, pick0, search_range, window_length) 

%----------initialize search quantities ----------% 

    NT0 = max(find(t<=t0));
    N0 = max(find(t<=pick0));
    N1 = max(find(t<=pick0-search_range(1)));
    N2 = max(find(t<=pick0+search_range(2))); 
    NS = N2-N0;
    NW = max(find(t<=pick0+window_length))-N0;
    mini_diff = search_range(1)+window_length;
    TN=length(t);

%-----check minimum waveform requirements-------%

    if(isempty(N1) | isempty(N2) | N1-NW<1 | length(u)~=TN)
        pick = -1; pick_snr = -2; return
    end
    
    if(pick0-t0<mini_diff)
        N1 = NT0+NW;
        if(N1>=N0)
            pick = -1; pick_snr = -1; return
        end
    end
    
    if(N2+NW>TN)
        N2 = TN-NW;
        if(N2<=N0)
            pick = -1; pick_snr = -2; return
        end
    end

%-----search largest amplitude change-----------%

    for i = N1:N2
        SNRD(i-N1+1) = snr(u(i:i+NW),u(i-NW:i));
        %SNRD(i-N1+1) = snr(u(i+1:i+NW),u(i-NW:i-1));
    end 
    NP_SNRD = max(find(SNRD>=max(SNRD)));
    pick_snr = SNRD(NP_SNRD);
    NP = N1-1+NP_SNRD;

%-------judge quality------------------------------%

    if(NP+NS>TN | NP-NS<1)
	    pick = -1; pick_snr = -3; % avoid overlap of O-P or P-S
    elseif(NP==N1 | NP==N2)
        pick = -1; pick_snr = -4; % avoid boundary effect
    else
        pick = t(NP); 
    end

%---------SNR function-----------------------------%

function r = snr(signal,noise)

r = (norm(signal)/norm(noise))^2;
